﻿Option Strict On
Imports System.Xml.Linq
Imports ImageTools
Imports ImageTools.IO.Gif

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' コンストラクター
    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myId As Integer
    Dim cityId As String = String.Empty
    Dim myNow As String = "today"
    Dim no As Integer = 0
    Private Sub goButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles goButton.Click
        nextButton.IsEnabled = True
        DataShow()
    End Sub


    Private Sub DataShow()
        Select Case no
            Case 0
                myNow = "today"
                prevButton.IsEnabled = False
                nextButton.IsEnabled = True
            Case 1
                myNow = "tomorrow"
            Case 2
                myNow = "dayaftertomorrow"
                nextButton.IsEnabled = False
                prevButton.IsEnabled = True
        End Select

        Dim myDate As String = DateTime.Now.AddDays(no).ToShortDateString


        ImageTools.IO.Decoders.AddDecoder(Of GifDecoder)()

        Dim myImage As ExtendedImage = New ExtendedImage

        Dim myUri As Uri = New Uri("http://weather.livedoor.com/forecast/rss/forecastmap.xml", UriKind.Absolute)

        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(myUri)


        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim xmldoc As XElement = XElement.Parse(resultArgs.Result)
                                                            Dim query = From c In xmldoc.Descendants("city") Where c.Attribute("title").Value.Equals(cityTextBox.Text) Select c
                                                            For Each result In query
                                                                cityId = result.Attribute("id").Value
                                                                myId = Integer.Parse(cityId)
                                                            Next

                                                            Dim wc As New WebClient
                                                            Dim _uri As Uri = New Uri(String.Format("http://weather.livedoor.com/forecast/webservice/rest/v1?city={0}&day={1}", myId, myNow), UriKind.Absolute)
                                                            wc.DownloadStringAsync(_uri)
                                                            AddHandler wc.DownloadStringCompleted, Sub(myresultSender As Object, myresultArgs As DownloadStringCompletedEventArgs)
                                                                                                       Try
                                                                                                           Dim doc As XElement = XElement.Parse(myresultArgs.Result)
                                                                                                           Dim area As String = doc.Descendants("title").First.Value
                                                                                                           areaTextBlock.Text = area & "(" & myDate & ")"
                                                                                                           Dim weather As String = doc.Descendants("image").Elements("title").Value
                                                                                                           weatherTextBlock.Text = weather
                                                                                                           Dim gifUri As String = doc.Descendants("image").Elements("url").Value
                                                                                                           myImage.UriSource = New Uri(gifUri, UriKind.Absolute)
                                                                                                       Catch
                                                                                                           MessageBox.Show("市が不正です。")
                                                                                                           no = 0
                                                                                                           nextButton.IsEnabled = False
                                                                                                           Exit Sub
                                                                                                       End Try
                                                                                                   End Sub




                                                        End Sub

        AddHandler myImage.LoadingCompleted, Sub(loadSender As Object, loadArgs As EventArgs)
                                                 Dispatcher.BeginInvoke(Sub()
                                                                            Image1.Source = myImage.ToBitmap
                                                                        End Sub)
                                             End Sub

    End Sub

    Private Sub nextButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles nextButton.Click

        If no = 2 Then
            no = 2

        Else
            no = no + 1
            nextButton.IsEnabled = True
        End If

        DataShow()
    End Sub

    Private Sub prevButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles prevButton.Click
        If no = 0 Then
            no = 0

        Else
            no = no - 1
            prevButton.IsEnabled = True
        End If

        DataShow()
    End Sub
End Class
